--- daemonlogger.c.orig	2008-11-24 14:56:48.000000000 -0500
+++ daemonlogger.c	2010-05-27 23:03:06.000000000 -0400
@@ -215,6 +215,7 @@
 static int flush_flag;
 static int maxpct;
 static int prune_flag;
+static int iso_date_flag;
 
 static char *interface;
 static char *retrans_interface;
@@ -414,29 +415,54 @@
 char *get_filename()
 {
     time_t currtime;
+    char atime[20];
 
     memset(logdir, 0, STDBUF);
     currtime = time(NULL);
-    if(logpath != NULL)
-    {
-        if(snprintf(logdir, 
-                    STDBUF, 
-                    "%s/%s.%lu", 
-                    logpath, 
-                    logfilename, 
-                    (long unsigned int) currtime) < 0)
-            return NULL;        
-    }
-    else
-    {
-        if(snprintf(logdir, 
-                    STDBUF, 
-                    "%s.%lu",
-                    logfilename,
-                    (long unsigned int) currtime) < 0)
-            return NULL;        
-    }
-
+	if (iso_date_flag) {
+		memset(atime, 0, 20);
+		strftime(atime, 19, "%Y%m%dT%H%M%S", localtime(&currtime));
+		
+		if(logpath != NULL)
+		{
+			if(snprintf(logdir, 
+						STDBUF, 
+						"%s/%s.%s", 
+						logpath, 
+						logfilename, 
+						atime) < 0)
+				return NULL;        
+		}
+		else
+		{
+			if(snprintf(logdir, 
+						STDBUF, 
+						"%s.%s",
+						logfilename,
+						atime) < 0)
+				return NULL;        
+		}
+	} else {
+		if(logpath != NULL)
+		{
+			if(snprintf(logdir, 
+						STDBUF, 
+						"%s/%s.%lu", 
+						logpath, 
+						logfilename, 
+						(long unsigned int) currtime) < 0)
+				return NULL;        
+		}
+		else
+		{
+			if(snprintf(logdir, 
+						STDBUF, 
+						"%s.%lu",
+						logfilename,
+						(long unsigned int) currtime) < 0)
+				return NULL;        
+		}
+	}
     return logdir;
 }
 
@@ -1120,6 +1206,7 @@
     printf("        -g <group name> Set group ID to <group name>\n");
     printf("        -h              Show this usage statement\n");
     printf("        -i <intf>       Grab packets from interface <intf>\n");
+    printf("        -j              Set filename timestamp to ISO 8601 basic format\n");
     printf("        -l <path>       Log to directory <path>\n");
     printf("        -m <count>      Generate <count> log files and quit\n");
     printf("        -M <pct>        In ringbuffer mode log data to <pct> of\n"
@@ -1152,7 +1239,7 @@
     int bpf_file = 0;
 
     while((ch = getopt(argc, argv, 
-            "c:df:Fg:hi:l:m:M:n:o:p:P:rR:s:S:t:T:u:vz"))!=-1)
+            "c:df:Fg:hi:jl:m:M:n:o:p:P:rR:s:S:t:T:u:vz"))!=-1)
     {
         switch(ch)
         {
@@ -1180,6 +1267,9 @@
             case 'i':
                 interface = strdup(optarg);
                 break;
+            case 'j':
+                iso_date_flag = 1;
+                break;
             case 'l':
                 logpath = strdup(optarg);
                 break;
@@ -1330,6 +1420,8 @@
         printf("[-] Max files to write set to %d\n", maxfiles);
     if(logfilename != NULL)
         printf("[-] Log filename set to \"%s\"\n", logfilename);
+	if (iso_date_flag)
+		printf("[-] Log filename using ISO 8601 format\n");
     if(retrans_interface != NULL)
         printf("[-] Tap output interface set to %s", retrans_interface);
     if(pidfile)
